echo off
% WAVEDEMO  Wave spectrum demonstration
%
% Author:   Thor I. Fossen
% Date:     2001-08-14
% Revisions: 

echo on; clf
% WAVEDEMO  Wave spectrum demonstration
%           Ref. T. I. Fossen (2002). Marine Control Systems: 
%           Guidance, Naigation and Control of Ships, Rigs and
%           Underwater Vehicles.
%
Hs   = 10;       % significant wave height
wmax = 3.0;      % maximum wave frequency
To   = 5.0;      % peak period of the wvae spectrum
wo   = 2*pi/To;  % peak frequency 

hold on

[w,S] = mpierson(Hs,wo,wmax);   % modified Pierson-Moskowitz spectrum

pause % Strike any key to continue

[w,S] = jonswap(Hs,wo,wmax);    % JONSWAP spectrum (default gamma = 3.3)
[w,S] = jonswap(Hs,wo,wmax,7);  % gamma = 7  

legend('Modified Pierson-Moskowitz','JONSWAP for \gamma=3.3','JONSWAP for \gamma=7.0')

pause % Strike any key to continue

[w,S] = torset(Hs,wo,wmax);

legend('Modified Pierson-Moskowitz','JONSWAP for \gamma=3.3','JONSWAP for \gamma=7.0','Torsethaugen')

hold off; grid; title('Significant wave height H_s = 10 m and peak period T_o = 5.0 (s)')

pause % Strike any key to return to MAIN MENU

close(1); echo off
disp('End of demo')

