% ExLinspec  linear approx. to PM, JONSWAP og Torsethaugen spectra using 
%            nonlinear least-squares(NLS)
%
% Author:    Thor I. Fossen
% Date:      15th August 2001
% Revisions: 

global sigma wo

wo = 1.2;  To = 2*pi/wo;
Hs = 10;
wmax = 3;

% Modified PM
subplot(311)
[w,S]=mpierson(Hs,wo,wmax);   sigma = sqrt(max(S));

lambda = lsqcurvefit('Slin', 0.1, w, S)

hold on; plot(w,Slin(lambda,w)/(Hs^2*To)); hold off; 
legend('Modified PM spectrum','linear approximation')

% JONSWAP
subplot(312)
[w,S]=jonswap(Hs,wo,wmax);   sigma = sqrt(max(S));

lambda = lsqcurvefit('Slin', 0.1, w, S)

hold on; plot(w,Slin(lambda,w)/(Hs^2*To)); hold off; 
legend('JONSWAP spectrum','linear approximation')

% Torsethaugen (only one peak is fitted)
subplot(313)
[w,S]=torset(Hs,wo,wmax);   sigma = sqrt(max(S));

lambda = lsqcurvefit('Slin', 0.1, w, S)

hold on; plot(w,Slin(lambda,w)/(Hs^2*To)); hold off; 
legend('Torsethaugen spectrum','linear approximation')

