% ExObsCtr   Observability and Controllability of Ships (see supply.m)
% Author:    Thor I. Fossen
% Date:      11 July 2002
% Revisions: 

format compact
disp('Controllabilty and observability of offShore supply vessel length 76 m')

% Normalization variables

L   =  76.2;           % length of ship (m)
g   =  9.8;            % acceleration of gravity (m/s^2)

T    = diag([1 1 L]);
Tinv = diag([1 1 1/L]);

% Model matricses
Mbis = [1.1274         0          0
             0    1.8902    -0.0744
             0   -0.0744     0.1278];

Dbis = [0.0358        0        0
             0        0.1183  -0.0124
             0       -0.0041   0.0308];

   
M = T*Mbis*Tinv
D = sqrt(g/L)*T*Dbis*Tinv          

% state space model
A = [ zeros(3,3) eye(3)
      zeros(3,3) -inv(M)*D ]

B = [zeros(3,3); inv(M) ]

C = [ eye(3) zeros(3,3) ]

n=rank(obsv(A,C))
n=rank(ctrb(A,B))
         
