function  [Vw]=hs2vw(Hs)
% This function converts the significan wave heihgt Hs into an equivalent wind
% speed Vw accodding to 
% 
%        Vw= sqrt((Hs*g/0.21));
%
% Use:  [Vw]=hs2vw(Hs)
% Hs -Significant wave height [m].
% Vw -Wind speed [m/s]
%
% Reference:
% T.I. Fossen (2002) "Marine Control Systems" Marine Cybernetics. 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Copyright (C) 2005 NTNU
%Created by: Tristan Perez in 2005  
% Last mod. by: TP
% Date: 2005-03-12
% Comments:  created for support of the old function pierson.m 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
g=9.81;
Vw= sqrt((Hs*g/0.21));