function [w,S] = jonswap(Hs,wo,wmax,gamma,N,plotflag)
% The function jonswap is now obsolete 
% and may no be supported in future versions of MSS. This function has been
% replaced by wavespec.m
%
%
% The same functionality of 
%   [w,S] = jonswap(Hs,wo,wmax,gamma,N,plotflag)
%
% can now be achieved using
%
%   w=linspace(0.01,wmax,N);
%   [S] =wavespec(7,[Hs,wo,gamma],w,plotflag);
%
%
% See wavespec for further details.
disp('-------------------------------------------------------------------------------------')
disp('MSS WARNING: The function jonswap is now obsolete and may no be supported in future') 
disp('             versions of MSS. This has been replaced by wavespec.m')
disp(' ')
disp(' ')
disp('See jonswap help for comments on how to obtain the same functionality with wavespec.')
disp('-------------------------------------------------------------------------------------')

w=linspace(0.01,wmax,N);
[S] =wavespec(7,[Hs,wo,gamma],w,plotflag);


% [w,S] = jonswap(Hs,wo,wmax,gamma,N,plotflag)
%
% Two parameter spectrum for developing sea.
% Returns the spectral density function S of the JONSWAP spectrum for the 
% frequencies:  0 < w < wmax (rad/s).
%
% Ouputs:
%   w		= vector of equally spaced wave spectrum frequencies (rad/s)
%   S		= vector of power spectral densities (m^2s)
%
% Inputs:
%   Hs		= significant wave height (m) - mean of the ones third highest waves
%   wo		= peak frequency (rad/s)
%   wmax	= maximum wave spectrum frequency:  0 < wo < wmax (rad/s)
%   gamma	= spectrum peak factor (optionally, default gamma = 3.3)
%   N		= number of equally spaced frequencies, optionally (default: N=100)
%	plotflag = 1 for plotting of spectrum, 0 for not
%
% Author:   Thor I. Fossen
% Date:     14th August 2001
%
% Revisions: 2005-02-28 ONS: Revised to comply with MSS, added plotflag

% if wo>=wmax, error('wmax must be larger than the peak frequency wo'); end
% if nargin==3, gamma = 3.3; N= 100; plotflag=1; end  
% if nargin==4, N = 100;  plotflag=1; end  
% if nargin==5, plotflag=1; end;
% 
% w = 0.01:wmax/N:wmax;
% 
% % wo = (4*B/5)^(1/4) and B = 944/T1^4;
% B = 5*wo^4/4;
% T1 = (944/B)^(1/4);
% A = 155*(Hs^2/T1^4);
% 
% for i=1:N,
%     if w(i)>5.24/T1,
%         sigma(i) = 0.09;
%     else
%         sigma(i) = 0.07;
%     end
% end
% 
% Y = exp(-((0.191.*w*T1-1)./(sqrt(2).*sigma)).^2);
% S = A.*w.^(-5).*exp(-B*w.^(-4)).*gamma.^Y;
% Tz = T1/1.073;
% 
% if plotflag == 1
% 
% 	figure
% 	plot(w, S/((2*pi/wo)*Hs^2),'r','linewidth',2)
% 	title('JONSWAP spectrum')
% 	xlabel('\omega (rad/s)')
% 	ylabel('Non-dimensional: S(\omega)/(H_s^2T_o)')
% 
% end
