function [w,S] = mpierson(Hs,w0,wmax,N,plotflag)
% The function mpierson is now obsolete 
% and may no be supported in future versions of MSS. This function has been
% replaced by wavespec.m
%
% The same functionality of
%    [w,S] = mpierson(Hs,w0,wmax,N,plotflag)
%
% can now be achieved using
%
%    w=linspace(0.01,wmax,N);
%    T0=2*pi/w0;
%    S=wavespec(3,[Hs,T0],w,plotflag);
%
%
% See wavespec for futher details.
disp('-------------------------------------------------------------------------------------')
disp('MSS WARNING: The function mpierson is now obsolete and may no be supported in future') 
disp('             versions of MSS. This has been replaced by wavespec.m')
disp(' ')
disp(' ')
disp('See mpierson help for comments on how to obtain the same functionality with wavespec.')
disp('-------------------------------------------------------------------------------------')

   w=linspace(0.01,wmax,N);
   T0=2*pi/w0;
   S=wavespec(3,[Hs,T0],w,plotflag);

   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
% [w,S] = mpierson(Hs,wo,wmax,N,plotflag)
%
% Two parameter spectrum for fully developed sea.
% Returns the spectral density function S of the Modified Pierson-Moskowitz 
% spectrum for the frequencies 0 < w < wmax.
%
% Ouputs:
%   w  = vector of equally spaced wave spectrum frequencies (rad/s)
%   S  = vector of power spectral densities (m^2s)
%
% Inputs:
%   Hs   = significant wave height (m) - mean of the ones third highest waves
%   wo   = peak frequency (rad/s)
%   wmax = maximum wave spectrum frequency:  0 < wo < wmax (rad/s)
%   N    = number of equally spaced frequencies, optionally (default: N=100)
%	plotflag = 1 for plotting of spectrum, 0 for not
%
% Author:   Thor I. Fossen
% Date:     11th August 2001
%
% Revisions: 2005-02-28 ONS: Revised to comply with MSS, added plotflag
%

% if wo>=wmax, error('wmax must be larger than the peak frequency wo'); end
% if nargin==4, plotflag=1; end;
% if nargin==3, N=100; plotflag=1; end;
% w = 0.01:wmax/N:wmax;
% 
% B = 5*wo^4/4;
% Tz = (16*pi^3/B)^(1/4);
% A = 4*pi^3*Hs^2/Tz^4;
% 
% S = A.*w.^(-5).*exp(-B*w.^(-4));
% 
% if plotflag == 1
% 
% 	figure
% 	plot(w, S/((2*pi/wo)*Hs^2),'g','linewidth',2)
% 	title('Modified Pierson-Moskowitz (PM) spectrum')
% 	xlabel('\omega (rad/s)')
% 	ylabel('Non-dimensional: S(\omega)/(H_s^2T_o)')
% 
% end