function y = rad2pipi(angle);
% RAD2PIPI Converts an angle in rad to the interval (-pi pi]
%          Should be applied to all heading errors in a feedback control system
%          in order to avoid discontinuities.
%
% Author:     Roger Skjetne
% Date:       2003-09-05
% Revisions:  2004-09-02 Thor I. Fossen - replaced input argument x with angle
%             2005-01-05 Thor I. Fossen - ouput argument is set to y and not angle
%             2005-04-13 Roger Skjetne  - changed the function s in order
%                                         to account for correct mapping to
%                                         (-pi pi].
%


% convert angle in rad to the interval <-pi pi> 
r = rem(angle+sign(angle)*pi,2*pi);
s = sign(sign(angle) + 2*(sign(abs(rem(angle+pi,2*pi)/(2*pi)))-1));
% s = sign(angle);

y = r - s*pi;
