function void = MSS_mask_page(npar)
% Set the visibility of simulink parameters dialog with npar parameter per page
% The first parameter of the dialog must be called page and be a popup menu

% Get the current value of parameter page
page = str2num(get_param(gcb,'page'));

% Number of dialog parameters
n = length(fieldnames(get_param(gcb,'DialogParameters')));

on = 'on';
off = 'off';

% Load current settings
onoff = get_param(gcb,'MaskVisibilities');

% Initialize values
onoff{1} = on;

for i = 2:n

	onoff{i} = off;
end

% Set active value

for i = ((page-1)*npar + 1):min(((page)*npar),n)

	onoff{i} = on;

end

set_param(gcb,'MaskVisibilities',onoff);



