% Models of Marine Vessels.
% Guidance, Navigation and Control Toolbox. 
% Date: 2005-02-05
%
% Creators:  Thor I. Fossen & Tristan Perez & yvind N. Smogeli & Asgeir J. Srensen
%
% Standard ship, semi-submersible and underwater vehicle models.
%
%    Ships:
%    mariner     - Mariner class vessel, L=160 m (nonlinear maneuvering model).
%    tanker      - Esso Osaka tanker, L=304 m (nonlinear course unstable maneuvering model).
%    container   - Container ship, L=175 m (nonlinear maneuvering model including the roll mode)
%    Lcontainer  - Container ship, L=175 m (LINEAR maneuvering model including the roll mode)
%
%    Underwater vehicles:
%    dsrv        - Deep submergence rescue vehicle (DSRV), L = 5.0 m
%    npsauv      - Naval Postgraduate School autnomous underwater vehicle (AUV), L = 5.3 m
%
%    See also simdemo.m
%
