function [amp,fase,w]=phbode(teller,nevner,w,am,fm,akser,farge,tau,tau2);

%phBODE er et mer fleksibelt og penere alternativ til BODE.
%phBODE tegner amplitudeforhold og faseforskyving i samme bode-
%diagram.  I tillegg takler det skikkelig tidsforsinkelse.
%
%function [amp,fase,w]=phbode(teller,nevner,w,am,fm,akser,farge,tau,tau2);
%
%Ved  bruke argumenter p venstre side fr du returnert alle verdiene, men ikke
%tegna opp bodediagram.
%
%Funskjonen kan ha fra 2 til 9 argumenter inn p hyre side ved vanlig utrekning.
%Funksjonen phbode(teller,nevner) tegner opp faseforskyving og amplitudeforhold
%i samme bodediagrammet med faste akser.  Variablene inni funksjonen er lokale.
%
%TIDSFORSINKELSE: Denne nye versjonen har en enklere mte  tekne opp bodediagram
%for overfringsfunksjoner.  Bare du holder rekkeflgen p argumentene kan du
%sette inn 'tau' som nest siste argument og tidsforsinkelsen du nsker som det 
%siste argumentet. Betingelsen er at 'tau' kan tidligst vre det tredje argumentet og
%seinest vre det ttende.  Du kan skrive phbode(teller,nevner,'tau',tau); 
%F eks phbode(1,[1 1 1],'tau',2);  Dette gir 2 sekunders tidsforsinkelse.
%
%Er du ikke fornyd med det automatisk valgte frekvensomrdet kan du bruke
%w=logspace(stardekade, sluttdekade, antallpunkter); for  generere ditt eget
%frekvensomrde.  Du m i s fall skrive: phbode(teller,nevner,w);
%
%Du kan ogs forskyve aksene ved  sette inn verdiene du nsker for amplitude og
%fase midt p y-aksene.  Du m i s fall skrive phbode(teller,nevner,w,am,fm);
%Aksene tegnes standard ved 0dB og -180grader.
%
%Dersom du vil spesifisere akser kan du legge p et sjette argument hvor: 0 gir bare
%0dB-akse,  1 gir 0dB-akse og 0grader-akse, 2 gir 0dB og -180grader akse.  Da m 
%du bruke phbode(teller,nevner,w,am,fm,akser);
%
%Dersom du vil spesifisere tegnefargen bruker du et sjuende argument som en streng p 
%ett tegn for  angi fargevalget: 'y' gir gul, 'm' gir magenta, 'c' gir cyan,
% 'r' gir rd, 'g' gir grnn, 'b' gir bl, 'w' gir hvit og 'k' gir svart.
%Du m bruke phbode(teller,nevner,w,am,fm,akser,'farge');
%
%Du kan ogs f tegna opp frekvensresponsen med skikkelig tidsforsinkelse som et
%alternativ til  bruke pade-approksimasjon.  Tidsforsinkelsen angis som det
%ttende argumentet.  Bruk phbode(teller,nevner,w,am,fm,akser,'farge',tau)
%
%Du kan ogs bruke phbode til plotting av mledata i bodediagrammet.  Du m da ha
%mledataene p matriseform hvor frste kolonne inneholder amplitudeforholdet, andre
%kolonne inneholder faseforskyvinga i grader og tredje kolonne inneholder frekvensen
%i rad/sek. Dersom amplitudeforholdet er et vanlig forholdstall kan du sette:
%	phbode(data) eller phbode(data,'-')
%Dersom amplitudeforholdet er i desibell m du skrive: phdata(data,'dB')
%
%Du kan ogs bruke flere parametre for  justere aksene osv p samme mte som ved 
%opptegning i phbode basert p overfringsfunksjonen.  Det tredje argumentet settes
%lik null, mens det fjerde str for dB midt p diagrammet.  Det femte str for 
%faseforskyving midt i diagrammet og det sjette str for de horisontale aksene.
%Det sjuende argumentet str for kurvefargen.
%  Eks: phbode(data,'dB',0,-6,-90,1,'g') plotter dataene basert p at amplitude-
%forholdet er i desiBell og gir -6 dB 0g -90 grader midt p diagrammet. O dB-linja 
%og 0 grader linja blir heltrukket.  Kurvene blir tegna i grnt.
%
%Laget av Per Hveem, HIST 5/10-95 Oppdatert 30/10-96 og 13/4-99
%
% Se ogs DAMP samt
% phLINMOD, phROOTS, phTF2ZP, phDAMP, phDDAMP, phPADE, phDBODE

xnargs=nargin;
if ((xnargs<1)&(xnargs>9)) error('phbode kan bare ta fra 1 til 9 argumenter'); end; 
nargs=0;
if xnargs>1 
   nevnersize=size(nevner);
   nevnerkolonner=nevnersize(2);
   nevkol=nevnerkolonner;
end;
if (xnargs<8) tau=0;  end;

if xnargs==3  if w(1)=='t' nargs=2; end; end;

if xnargs==4  if w(1)=='t' tau=am; nargs=2; end; 
					if am(1)=='t' nargs=3; end;  end;

if xnargs==5  if am(1)=='t' tau=fm; nargs=3; end; 
					if fm(1)=='t' nargs=4; end;  end;

if xnargs==6  if fm(1)=='t' tau=akser; nargs=4; end; 
					if akser(1)=='t' nargs=5; end;  end;

if xnargs==7  if akser(1)=='t' tau=farge; nargs=5; end; 
					if farge(1)=='t' nargs=6; end;  end;

if xnargs==8  if farge(1)=='t' tau=tau; nargs=6; end; 
              if tau(1)=='t' nargs=7; tau=0; end;  end;

if xnargs==9  if tau(1)=='t' tau=tau2; nargs=7; end; 
					if tau2(1)=='t' nargs=8; end;  end;

if nargs==0 nargs=xnargs; end;

if ((nargs==1)|((nargs>1)&((nevner(1)=='-')|(nevner(1)=='d')))) %plotting fra datafil:
   fase=teller(:,2);w=teller(:,3);tau=0; if nargs<3 nargs=3; end;
   if (nevner(1)=='d') amp=exp(teller(:,1)/20*log(10));
   else amp=teller(:,1); end;
else %utrekning basert p overfringsfunksjon og s plotting:
   if nargs==2 [amp,fase,w]=bode(teller,nevner); nargs=3; else [amp,fase,w]=bode(teller,nevner,w); end;
end;   

if nargs==3  am=0; fm=-180; akser=2;farge='r';end;
if nargs==4  fm=-180; akser=2;farge='r';end;
if nargs==5  akser=2;farge='r';end;
if nargs==6  farge='r';end;

fi=tau*w*180/pi;fase=fase-fi;

%N skal alle med gyldige data ha ftt 8 parametre som kan plottes;

if nargout==0
   fasfarge=[farge '-' '-'];
   ampfarge=[farge '-'];
   if ishold==0 clf; end;
   %De fire linjene under srger for at vinkler mellom 0 og +360 ogs blir tegna opp!
   n=length(w);
   for j=1:n
      if fase(j)>(fm+180); fase(j)=fase(j)+(fm+180-360); end;
   end;  
   set(gca,'position',[0.1 .11 .77 .81]);
   holdon=ishold;
   if holdon hold on; end;
%*************************************************

%************************************************
  % axis([min(w) max(w) am-36 am+36]);
   y=am-36:6:am+36;
   set(gca,'YTick',y);
   set(gca,'GridLineStyle',':');
   grid on;
   h=(gca);
   %-180 grader akse:
   if akser==2;
      semilogx([min(w) max(w)],[0.2*(-180)+0-0.2*fm+am 0.2*(-180)+0-0.2*fm+am],'m--');
      hold on;
   end;
   %0 grader akse:
   if akser==1;
      semilogx([min(w) max(w)],[0.2*(-0)+0-0.2*fm+am 0.2*(-0)+0-0.2*fm+am],'m-');
      hold on;
   end;
   semilogx([min(w) max(w)],[0 0],'b');
   grid on;
%***********
   hold on;
   %(axisfunskjonen gjr det mulig  kontrollere aksene som brukes: xmin xmax, ymin )
   %grid;
%*********************************************
%*************************************************
   semilogx(w,20*log10(amp),ampfarge);
   hold on;
   semilogx(w,0.2*fase+0-0.2*fm+am,fasfarge);


%************************************************
   axes('position',[0.975 .11 .005 .81]);
   axis([0 0.1 fm-180 fm+180]);
   y=fm-180:30:fm+180;
   set(gca,'Ytick',y);
   %set(gca,'Xtick',0);
   ylabel('Faseforskyving i grader');
   axes(h);
   title('Bodediagram for prosess (amp:hel, fas:delt)');
   ylabel('Amplitudeforhold i dB');
   xlabel('Radianer pr sek');
   hold off;
   grid on;
   
   %Ser ut som at axis ikke funker her heller:
   %axis([min(w) max(w) am-36 am+36]);
   %Axis funker ikke.  M bruke 'YLim' og 'XLim' i stedet:
   %YLim funker, men XLim funker ikke med variabelnavn - bare med tall
   %set(get(1,'CurrentAxes'),'YLim',[am-36 am+36]);
   %minw=min(w);
   %maxw=max(w);
   %set(h,'XLim',[minw maxw]);
   %set(h,'XLim',[-0.01 100]);
   %set(h,'XLim',[min(w) max(w)]);
   set(h,'YLim',[am-36 am+36]);
   y=am-36:6:am+36;
   set(gca,'YTick',y);
   grid on;
end;
