function [amp,fase,w]=phmbode(teller,nevner,w,am,fm,akser,farge,tau,tau2);

%function [amp,fase,w]=phmbode(teller,nevner,w,am,fm,akser,farge,tau,tau2);
%
%phmbode kombinerer opptegning i bodediagram p samme mte som phbode, men
%tegner i tillegg opp fasemargin og forsterkingsmargin og kryssfrekvenser.
%Verdiene skrives opp som overskrift. Funksjonen baserer seg ikke p MARGIN, fordi
%MARGIN kan gi feil resultat dersom faseforskyvinga gr under -180 grader. 
%
%Ved  bruke argumenter p venstre side fr du returnert alle verdiene, men ikke
%tegna opp bodediagram.
%
%Funskjonen kan ha fra 2 til 9 argumenter inn p hyre side ved vanlig utrekning.
%Funksjonen phmbode(teller,nevner) tegner opp faseforskyving og amplitudeforhold
%i samme bodediagrammet med faste akser.  Variablene inni funksjonen er lokale.
%
%TIDSFORSINKELSE: Denne nye versjonen har en enklere mte  tekne opp bodediagram
%for overfringsfunksjoner.  Bare du holder rekkeflgen p argumentene kan du
%sette inn 'tau' som nest siste argument og tidsforsinkelsen du nsker som det 
%siste argumentet. Betingelsen er at 'tau' kan tidligst vre det tredje argumentet og
%seinest vre det ttende.  Du kan skrive phmbode(teller,nevner,'tau',tau); 
%F eks phmbode(1,[1 1 1],'tau',2);  Dette gir 2 sekunders tidsforsinkelse.
%
%Er du ikke fornyd med det automatisk valgte frekvensomrdet kan du bruke
%w=logspace(stardekade, sluttdekade, antallpunkter); for  generere ditt eget
%frekvensomrde.  Du m i s fall skrive: phmbode(teller,nevner,w);
%
%Du kan ogs forskyve aksene ved  sette inn verdiene du nsker for amplitude og
%fase midt p y-aksene.  Du m i s fall skrive phmbode(teller,nevner,w,am,fm);
%Aksene tegnes standard ved 0dB og -180grader.
%
%Dersom du vil spesifisere akser kan du legge p et sjette argument hvor: 0 gir bare
%0dB-akse,  1 gir 0dB-akse og 0grader-akse, 2 gir 0dB og -180grader akse.  Da m 
%du bruke phmbode(teller,nevner,w,am,fm,akser);
%
%Dersom du vil spesifisere tegnefargen bruker du et sjuende argument som en streng p 
%ett tegn for  angi fargevalget: 'y' gir gul, 'm' gir magenta, 'c' gir cyan,
% 'r' gir rd, 'g' gir grnn, 'b' gir bl, 'w' gir hvit og 'k' gir svart.
%Du m bruke phmbode(teller,nevner,w,am,fm,akser,'farge');
%
%Du kan ogs f tegna opp frekvensresponsen med skikkelig tidsforsinkelse som et
%alternativ til  bruke pade-approksimasjon.  Tidsforsinkelsen angis som det
%ttende argumentet.  Bruk phmbode(teller,nevner,w,am,fm,akser,'farge',tau)
%
%Du kan ogs bruke flere parametre for  justere aksene osv p samme mte som ved 
%opptegning i phmbode basert p overfringsfunksjonen.  Det tredje argumentet settes
%lik null, mens det fjerde str for dB midt p diagrammet.  Det femte str for 
%faseforskyving midt i diagrammet og det sjette str for de horisontale aksene.
%Det sjuende argumentet str for kurvefargen.
%  Eks: phmbode(data,'dB',0,-6,-90,1,'g') plotter dataene basert p at amplitude-
%forholdet er i desiBell og gir -6 dB 0g -90 grader midt p diagrammet. O dB-linja 
%og 0 grader linja blir heltrukket.  Kurvene blir tegna i grnt.


%%Laget av Per Hveem, HIST 5/10-95 og oppdatert 9/11-01

%Se ogs MARGIN, phMBODE2, phBODE og phDBODE

xnargs=nargin;
if ((xnargs<1)&(xnargs>9)) error('phbode kan bare ta fra 1 til 9 argumenter'); end; 
nargs=0;
if xnargs>1 
   nevnersize=size(nevner);
   nevnerkolonner=nevnersize(2);
   nevkol=nevnerkolonner;
end;
if (xnargs<8) tau=0;  end;

if xnargs==3  if w(1)=='t' nargs=2; end; end;

if xnargs==4  if w(1)=='t' tau=am; nargs=2; end; 
					if am(1)=='t' nargs=3; end;  end;

if xnargs==5  if am(1)=='t' tau=fm; nargs=3; end; 
					if fm(1)=='t' nargs=4; end;  end;

if xnargs==6  if fm(1)=='t' tau=akser; nargs=4; end; 
					if akser(1)=='t' nargs=5; end;  end;

if xnargs==7  if akser(1)=='t' tau=farge; nargs=5; end; 
					if farge(1)=='t' nargs=6; end;  end;

if xnargs==8  if farge(1)=='t' tau=tau; nargs=6; end; 
              if tau(1)=='t' nargs=7; tau=0; end;  end;

if xnargs==9  if tau(1)=='t' tau=tau2; nargs=7; end; 
					if tau2(1)=='t' nargs=8; end;  end;

if nargs==0 nargs=xnargs; end;

if ((nargs==1)|((nargs>1)&((nevner(1)=='-')|(nevner(1)=='d')))) %plotting fra datafil:
   fase=teller(:,2);w=teller(:,3);tau=0; if nargs<3 nargs=3; end;
   if (nevner(1)=='d') amp=exp(teller(:,1)/20*log(10));
   else amp=teller(:,1); end;
else %utrekning basert p overfringsfunksjon og s plotting:
   if nargs==2 [amp,fase,w]=bode(teller,nevner); nargs=3; else [amp,fase,w]=bode(teller,nevner,w); end;
end;   

if nargs==3  am=0; fm=-180; akser=2;farge='r';end;
if nargs==4  fm=-180; akser=2;farge='r';end;
if nargs==5  akser=2;farge='r';end;
if nargs==6  farge='r';end;

%For  f vinklene i omrdet +180 til -180 over til 0mrdet 0 til -360:
n=length(w);
for j=1:n; 
    if fase(j)>0 fase(j)=fase(j)-360;end;
end;
fi=tau*w*180/pi;fase=fase-fi;

%N skal alle med gyldige data ha ftt 8 parametre som kan plottes;


%Utregning av marginer og kryssfrekvenser:
%[gm,fm,w180,wc]=margin(amp,fase,w);

%Likningene under finner w180 og w0 til nrmeste w lavere enn rett w:
w180=min(w); wc=min(w);
stopp=0;
for j=1:(n-1)
    if fase(j)<-270; stopp=1;end;
	if (fase(j)>-180 & fase(j+1)<=-180) & stopp==0;
        stopp=1; w180=w(j); gm=1/amp(j); 
        jg=j; 
    end;
	if amp(j)>1; wc=w(j); fm=fase(j)+180; jf=j; end;
    %linja under srger for at vinkler mellom 0 og +360 blir tegna opp!
%    if fase(j)>0; fase(j)=fase(j)-360; end;
%     %*************
%     % Prver  fange opp fase som starter under -180, men over -210
%     %for  se om fasen gr over -180 lenger ut:
%     if fase(1)<-180 & fase(1)>-210; 
%         if fase(j)
%         
%     %***************

end;  

%Lkningene under prver  interpolere rett w180 mellom nrmeste w over og under:
% if w180==min(w) |w180==max(w); w180=NaN; gm=NaN;
% 	elseif fase(jg)>-180; 
% 		a0=amp(jg); a2=amp(jg+1); 
% 		w0=w(jg); w2=w(jg+1);
% 		fi0=fase(jg); fi2=fase(jg+1);
% 		w1=w0-(-180-fi2)*(w2-w0)/(fi2-fi0);
% 		a1=a0+(w1-w0)*(a2-a0)/(w2-w0);
% 		w180=w1;
% 		gm=1/a1;
% 	end;
% end;

% %Lkningene under prver  interpolere rett wc mellom nrmeste w over og under:
% if wc==min(w) |wc==max(w); wc=NaN; fm=NaN; 
% 	elseif amp(jf)>0; 
% 		a0=amp(jf); a2=amp(jf+1);
% 		w0=w(jf); w2=w(jf+1);
% 		fi0=fase(jf); fi2=fase(jf+1);
% 		w1=w0+(1-a0)*(w2-w0)/(a2-a0);
% 		fi1=fi0+(w1-w0)*(fi2-fi0)/(w2-w0);
% 		wc=w1;
% 		fm=fi1+180;
% 	end;
% end;

%Lkningene under prver  interpolere rett w180 mellom nrmeste w over og under:
if w180==min(w) |w180==max(w); w180=NaN; gm=NaN;
elseif fase(jg)>-180;
%        fasegml=fase(jg)
        w0=w(jg); w2=w(jg+1);
        while ((w2-w0)/w2)>0.001          
            w1=(w0+w2)/2;
            [ampny,faseny,wny]=bode(teller,nevner,w1);
            faseny(1);
            if faseny(1)>0 faseny(1)=faseny(1)-360; 
            end;
            fi=tau*wny(1)*180/pi;faseny(1)=faseny(1)-fi;
            if faseny(1)>-180; w180=wny(1); gm=1/ampny(1); w0=w1; 
            else w2=w1;
            end;
        end;              
end;


%Lkningene under prver  interpolere rett w0 mellom nrmeste w over og under:
if wc==min(w) |wc==max(w); wc=NaN; fm=NaN; 
elseif amp(jf)>1; 
		w0=w(jf); w2=w(jf+1);
        while ((w2-w0)/w2)>0.001          
            w1=(w0+w2)/2;
            [ampny,faseny,wny]=bode(teller,nevner,w1);
            ampny(1);
            if faseny(1)>0 faseny=faseny-360; end;
            fi=tau*wny(1)*180/pi;faseny(1)=faseny(1)-fi;
            if ampny(1)>1; wc=wny(1); fm=faseny(1)+180; 
                w0=w1;
            else w2=w1;
            end;
        end;          
        if wc>w180 & fm>0; fm=fm-360;
	    end;
end;

set(gca,'position',[0.1 .11 .77 .81]);
holdon=ishold;
if holdon hold on; end;
semilogx(w,20*log10(amp),'r');
hold on;
semilogx(w,0.2*fase+36,'r--');
axis([min(w) max(w) -36 36]);
y=-36:6:36;
set(gca,'YTick',y);
h=(gca);
semilogx([min(w) max(w)],[0 0],'b');
%(axisfunskjonen gjr det mulig  kontrollere aksene som brukes: xmin xmax, ymin )
%grid;
set(gca,'GridLineStyle',':');
grid on;
axes('position',[0.975 .11 .005 .81]);
axis([0 0.1 -360 0]);
y=-360:30:0;
set(gca,'Ytick',y);
set(gca,'Xtick',0);
ylabel('Faseforskyving i grader');
axes(h);
if w180>min(w) & w180<max(w)
	semilogx([w180;w180],[-20*log10(gm) 0],'g');
end
if fm<-360; fn=-360; else fn=fm; end;
if wc>min(w) & wc<max(w)
	semilogx([wc;wc],[(-180+fn)*0.2+36 -180*0.2+36],'g');
end
if wc>w180; text(min(w)*2,2,'USTABIL MED NEGATIV dK og dFi','FontSize',18,'Color','k'); end;
title(['dK=',sprintf('%.2g',real(20*log10(gm))), ' dB ',...
		' (Kk= ',sprintf('%.3g',real(gm)), ...
		'), w180= ',sprintf('%.3g',real(w180)), ...
		' (Tk=', sprintf('%.3g',real(2*pi/w180)), ...
		'),  dFi=', sprintf('%.3g',real(fm)), ' deg.,', ...
		' wc=', sprintf('%.3g',real(wc)), ]);

%title('Bodediagram for prosess (amp:hel, fas:delt)');
ylabel('Amplitudeforhold i dB');
xlabel('Radianer pr sek');
hold off;
%end
%sprintf('%.4g',real(x));