function [pwnum,pwden,knekkfrekvenser]=phprewarp(num,den,Ts)
%20/3 2002 : Tar teller og nevneren til en overfringsfunksjon eller et enkelt polynom i s-planet og lager en ny
%overfringsfunksjon hvor alle knekkfrekvensene er forhndsbyd.  Denne nye overfrings-
%funksjonen kan overfres til z-planet med 'tustin' dvs trapesmetoden. Samplingstida Ts for det tidsdiskrete system
%m oppgis.  Det er ogs mulig  f returnert knekkfrekvenser fr og etter forhndsbying.
% Eksempler: [prewarpedpoly,knekkfrekvenser]=phprewarp(polynom,Ts)
%            [prewarpedteller,prewarpednevner,knekkfrekvenser]=phprewarp(teller,nevner,Ts)
%Laget av Per Hveem, HIST 20/3-2002 basert p prewarper laget av Per Hveem 20/3 2002
nargs=nargin;
if  (nargs<2) | (nargs>3) error('phprewarp kan bare ta 2 eller 3 argumenter: (polynom,Ts) eller (num,den,Ts)');
end;
if nargs==2   %Et polynom!
    if num == 0 error('Hele tellerpolynomet kan ikke vre null');
    end    
    if den == 0 error('Samplingstida kan ikke vre null');
    end    
	Ts=den; 
	%teller:
	[pwnum,knekknum]=prewarper(num,Ts);
	pwden=knekknum;
end
if nargs==3 %Et tellerpolynom og et nevnerpolynom!
    if num == 0 error('Hele tellerpolynomet kan ikke vre null');
    end    
    if den == 0 error('Hele nevnerpolynomet kan ikke vre null');
    end    
    if Ts == 0 error('Samplingstida kan ikke vre null');
    end    
	[pwnum,knekknum]=prewarper(num,Ts);
	%nevner:
	[pwden,knekkden]=prewarper(den,Ts);
	%knekkfrekvenser:
	knekkfrekvenser=[knekknum;knekkden];
end


function [wpolyn,knekk]=prewarper(polyn,Ts)
%Ny versjon Per Hveem 20/3 2002.
%Den nye versjonen bruker knekkfrekvensen som kritisk frekvens for
%komplekskonjugerte poler og knekkfrekvensen for reelle poler
nargs=nargin;
if  nargs~=2 error('warper kan bare ta 2 argumenter');
end;
%m sjekke om hele polynomet bestr av bare nuller:
if polyn == 0 error('Hele polynomet kan ikke vre null');
end
%slutt nullsjekk her!
if length(polyn)>1
	r=roots(polyn);
    %m sjekke om noen av rttene er null
	q=0;
	rny=0;
	for k=1:length(r);
        if r(k,1)==0 q=k; rny(k)=0; end 
	end             	
        ir=imag(r);
		rr=real(r);
		wk=abs(r);
		wp= 2*tan(wk*Ts/2)/Ts;
        for i=(q+1):length(r)
           rny(i)=wp(i)/wk(i)*(rr(i)+ir(i)*j);
		end 
        if q==length(polyn) wpolyn=0
        else
			wpoly=poly(rny)
			m=length(polyn)-q;
			n=length(wpoly)-q;
			wpolyn=polyn(m)/wpoly(n)*wpoly;
		end
else
    wpolyn=polyn;
%     wk=0;
%     wp=0;
end
knekk=([wk,wp]')';